using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using NationalInstruments.UI;
using NationalInstruments.NI4882;

namespace harompaneles
{
    public partial class Form1 : Form
    {

        DateTime startTime;
        TimeSpan elapsedTime;

        string dataName1;
        string dataName2;
        string dataName3;
        string dataName4;
        string dataName5;
        string dataName6;

        double data1;
        double data2;
        double data3;
        double data4;
        double data5;
        double data6;

        StreamWriter fileWriter;

        Random rnd;

        //NationalInstruments.NI4882.Device GPIBdev1;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            dataName1 = "time";
            dataName2 = "temperature";
            dataName3 = "resistance1";
            dataName4 = "resistance2";
            dataName5 = "empty";
            dataName6 = "empty";

            dataLabel1.Text = dataName1;
            dataLabel2.Text = dataName2;
            dataLabel3.Text = dataName3;
            dataLabel4.Text = dataName4;
            dataLabel5.Text = dataName5;
            dataLabel6.Text = dataName6;

            rnd = new Random();


            // Initializing GPIB devices

            // byte port = 21; 

           // try
           // {
           //     GPIBdev1 = new NationalInstruments.NI4882.Device(1, port);
           // }
           // catch (Exception ex)
           // {
           //     MessageBox.Show(ex.ToString());
           //     return;
           // }
            


            SaveFileDialog sfDialog = new SaveFileDialog();

            sfDialog.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*" ;
            sfDialog.FilterIndex = 1;
            sfDialog.RestoreDirectory = true; 

            if (sfDialog.ShowDialog() == DialogResult.OK)
            {

                fileWriter = new StreamWriter(sfDialog.FileName);
                fileWriter.AutoFlush = true;

            }

             // todo: handle DialogResult.Cancel

            fileWriter.WriteLine(dataName1 + "\t" + dataName2 + "\t" + dataName3 + "\t" + dataName4 + "\t" + dataName5 + "\t" + dataName6);

            timer1.Interval = Convert.ToInt32(TimerInterval.Text);
            timer1.Enabled = true;

            startTime = DateTime.Now;

        }

        private void timer1_Tick(object sender, EventArgs e)
        {

            double GraphPoint1X;
            double GraphPoint1Y;

            double GraphPoint2X;
            double GraphPoint2Y;

            double GraphPoint3X;
            double GraphPoint3Y;

            string response;

            elapsedTime = DateTime.Now - startTime;

            //GPIBdev1.Write("FREQ?");
            //response = GPIBdev1.ReadString();

            data1 = elapsedTime.TotalSeconds;
            //data2 = Convert.ToDouble(response);
            data2 = rnd.NextDouble();
            data3 = rnd.NextDouble();
            data4 = rnd.NextDouble();
            data5 = data1;
            data6 = rnd.NextDouble();

            //'Filling the data variables

            dataBox1.Text = data1.ToString("0.0");
            dataBox2.Text = data2.ToString();
            dataBox3.Text = data3.ToString();
            dataBox4.Text = data4.ToString();
            dataBox5.Text = data5.ToString();
            dataBox6.Text = data6.ToString();


            //'X and Y value of the new point on graph 1
            GraphPoint1X = data1;
            GraphPoint1Y = data2;

            //'X and Y value of the new point on graph 2
            GraphPoint2X = data2;
            GraphPoint2Y = data3;

            //'X and Y value of the new point on graph 3
            GraphPoint3X = data3;
            GraphPoint3Y = data4;

            //'Plotting the new points on the graph

            scatterGraph1.PlotXYAppend(GraphPoint1X, GraphPoint1Y);
            scatterGraph2.PlotXYAppend(GraphPoint2X, GraphPoint2Y);
            scatterGraph3.PlotXYAppend(GraphPoint3X, GraphPoint3Y);

            //'Saving the data
            SaveDataPoint();

        }

        private void switch1_StateChanged(object sender, NationalInstruments.UI.ActionEventArgs e)
        {
            switch (timer1.Enabled)
            {
                case true:
                    timer1.Enabled = false;
                    break;
                case false:
                    timer1.Enabled = true;
                    break;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            timer1.Interval = Convert.ToInt32(TimerInterval.Text);
        }

        private void SaveDataPoint()
        {
            fileWriter.WriteLine(data1.ToString("0.00") + "\t" + data2.ToString() + "\t" + data3.ToString() + "\t" +
            data4.ToString() + "\t" + data5.ToString() + "\t" + data6.ToString());

            fileWriter.Flush();

        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                //fileWriter.Flush();
                fileWriter.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }


        // ###################### graph 1 ############################
        
        private void graph1AutoY_CheckedChanged(object sender, EventArgs e)
        {
            switch (graph1AutoY.Checked)
            {
                case true:
                    scatterGraph1.Plots[0].YAxis.Mode = AxisMode.AutoScaleLoose;
                    break;
                case false:
                    scatterGraph1.Plots[0].YAxis.Mode = AxisMode.Fixed;

                    if (graph1MaxY.Value > graph1MinY.Value)
                    scatterGraph1.Plots[0].YAxis.Range = new Range(graph1MinY.Value,graph1MaxY.Value);
                    break;
            }

        }

        private void graph1MinY_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            graph1AutoY_CheckedChanged(sender, e);
        }

        private void graph1MaxY_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            graph1AutoY_CheckedChanged(sender, e);
        }

        private void graph1LogY_CheckedChanged(object sender, EventArgs e)
        {
            switch (graph1LogY.Checked)
            {
                case true:
                    scatterGraph1.Plots[0].YAxis.ScaleType = ScaleType.Logarithmic;
                    break;
                case false:
                    scatterGraph1.Plots[0].YAxis.ScaleType = ScaleType.Linear;
                    break;
            }
        }

        private void graph1AutoX_CheckedChanged(object sender, EventArgs e)
        {
            switch (graph1AutoX.Checked)
            {
                case true:
                    scatterGraph1.Plots[0].XAxis.Mode = AxisMode.AutoScaleLoose;
                    break;
                case false:
                    scatterGraph1.Plots[0].XAxis.Mode = AxisMode.Fixed;

                    if (graph1MaxX.Value > graph1MinX.Value)
                        scatterGraph1.Plots[0].XAxis.Range = new Range(graph1MinX.Value, graph1MaxX.Value);
                    break;
            }
        }

        private void graph1MinX_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            graph1AutoX_CheckedChanged(sender, e);
        }

        private void graph1MaxX_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            graph1AutoX_CheckedChanged(sender, e);
        }

        private void graph1LogX_CheckedChanged(object sender, EventArgs e)
        {
            switch (graph1LogX.Checked)
            {
                case true:
                    scatterGraph1.Plots[0].XAxis.ScaleType = ScaleType.Logarithmic;
                    break;
                case false:
                    scatterGraph1.Plots[0].XAxis.ScaleType = ScaleType.Linear;
                    break;
            }
        }


        // ###################### graph 2 ############################

        private void graph2AutoY_CheckedChanged(object sender, EventArgs e)
        {
            switch (graph2AutoY.Checked)
            {
                case true:
                    scatterGraph2.Plots[0].YAxis.Mode = AxisMode.AutoScaleLoose;
                    break;
                case false:
                    scatterGraph2.Plots[0].YAxis.Mode = AxisMode.Fixed;

                    if (graph2MaxY.Value > graph2MinY.Value)
                        scatterGraph2.Plots[0].YAxis.Range = new Range(graph2MinY.Value, graph2MaxY.Value);
                    break;
            }
        }

        private void graph2MinY_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            graph2AutoY_CheckedChanged(sender, e);
        }

        private void graph2MaxY_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            graph2AutoY_CheckedChanged(sender, e);
        }

        private void graph2LogY_CheckedChanged(object sender, EventArgs e)
        {
            switch (graph2LogY.Checked)
            {
                case true:
                    scatterGraph2.Plots[0].YAxis.ScaleType = ScaleType.Logarithmic;
                    break;
                case false:
                    scatterGraph2.Plots[0].YAxis.ScaleType = ScaleType.Linear;
                    break;
            }
        }

        private void graph2AutoX_CheckedChanged(object sender, EventArgs e)
        {
            switch (graph2AutoX.Checked)
            {
                case true:
                    scatterGraph2.Plots[0].XAxis.Mode = AxisMode.AutoScaleLoose;
                    break;
                case false:
                    scatterGraph2.Plots[0].XAxis.Mode = AxisMode.Fixed;

                    if (graph2MaxX.Value > graph2MinX.Value)
                        scatterGraph2.Plots[0].XAxis.Range = new Range(graph2MinX.Value, graph2MaxX.Value);
                    break;
            }
        }

        private void graph2MinX_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            graph2AutoX_CheckedChanged(sender, e);
        }

        private void graph2MaxX_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            graph2AutoX_CheckedChanged(sender, e);
        }

        private void graph2LogX_CheckedChanged(object sender, EventArgs e)
        {
            switch (graph2LogX.Checked)
            {
                case true:
                    scatterGraph2.Plots[0].XAxis.ScaleType = ScaleType.Logarithmic;
                    break;
                case false:
                    scatterGraph2.Plots[0].XAxis.ScaleType = ScaleType.Linear;
                    break;
            }
        }

        // ###################### graph 3 ############################

        private void graph3AutoY_CheckedChanged(object sender, EventArgs e)
        {
            switch (graph3AutoY.Checked)
            {
                case true:
                    scatterGraph3.Plots[0].YAxis.Mode = AxisMode.AutoScaleLoose;
                    break;
                case false:
                    scatterGraph3.Plots[0].YAxis.Mode = AxisMode.Fixed;

                    if (graph3MaxY.Value > graph3MinY.Value)
                        scatterGraph3.Plots[0].YAxis.Range = new Range(graph3MinY.Value, graph3MaxY.Value);
                    break;
            }
        }

        private void graph3MinY_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            graph3AutoY_CheckedChanged(sender, e);
        }

        private void graph3MaxY_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            graph3AutoY_CheckedChanged(sender, e);
        }

        private void graph3LogY_CheckedChanged(object sender, EventArgs e)
        {
            switch (graph3LogY.Checked)
            {
                case true:
                    scatterGraph3.Plots[0].YAxis.ScaleType = ScaleType.Logarithmic;
                    break;
                case false:
                    scatterGraph3.Plots[0].YAxis.ScaleType = ScaleType.Linear;
                    break;
            }
        }

        private void graph3AutoX_CheckedChanged(object sender, EventArgs e)
        {
            switch (graph3AutoX.Checked)
            {
                case true:
                    scatterGraph3.Plots[0].XAxis.Mode = AxisMode.AutoScaleLoose;
                    break;
                case false:
                    scatterGraph3.Plots[0].XAxis.Mode = AxisMode.Fixed;

                    if (graph3MaxX.Value > graph3MinX.Value)
                        scatterGraph3.Plots[0].XAxis.Range = new Range(graph3MinX.Value, graph3MaxX.Value);
                    break;
            }
        }

        private void graph3MinX_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            graph3AutoX_CheckedChanged(sender, e);
        }

        private void graph3MaxX_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            graph3AutoX_CheckedChanged(sender, e);
        }

        private void graph3LogX_CheckedChanged(object sender, EventArgs e)
        {
            switch (graph3LogX.Checked)
            {
                case true:
                    scatterGraph3.Plots[0].XAxis.ScaleType = ScaleType.Logarithmic;
                    break;
                case false:
                    scatterGraph3.Plots[0].XAxis.ScaleType = ScaleType.Linear;
                    break;
            }
        }

        private void groupBox4_Enter(object sender, EventArgs e)
        {

        }



    }
}